Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 2231)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 2232)
@@ -550,21 +503,60 @@
 
                       DO  j = nys, nyn
-                         DO  k = nzb_diff_s_inner(j,i), nzt_diff
-                            tend(k,j,i) = tend(k,j,i) -                   &
-                                          kh(k,j,i) * g / pt_reference *  &
-                                          ( pt(k+1,j,i) - pt(k-1,j,i) ) * &
-                                          dd2zu(k)
+                         DO  k = nzb+1, nzt
+!
+!--                         Flag 9 is used to mask top fluxes, flag 30 to mask
+!--                         surface fluxes
+                            tend(k,j,i) = tend(k,j,i) -                        &
+                                          kh(k,j,i) * g / pt_reference  *      &
+                                          ( pt(k+1,j,i) - pt(k-1,j,i) ) *      &
+                                          dd2zu(k)                      *      &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 30 )  &
+                                           )                            *      &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 9 )   &
+                                           )  
                          ENDDO
 
                          IF ( use_surface_fluxes )  THEN
-                            k = nzb_diff_s_inner(j,i)-1
-                            tend(k,j,i) = tend(k,j,i) + g / pt_reference * &
-                                                        shf(j,i)
+!
+!--                         Default surfaces, up- and downward-facing
+                            DO  l = 0, 1
+                               surf_s = surf_def_h(l)%start_index(j,i)
+                               surf_e = surf_def_h(l)%end_index(j,i)
+                               DO  m = surf_s, surf_e
+                                  k = surf_def_h(l)%k(m)
+                                  tend(k,j,i) = tend(k,j,i) + g / pt_reference &
+                                                         * surf_def_h(l)%shf(m)   
+                               ENDDO   
+                            ENDDO      
+!
+!--                         Natural surfaces
+                            surf_s = surf_lsm_h%start_index(j,i)
+                            surf_e = surf_lsm_h%end_index(j,i)
+                            DO  m = surf_s, surf_e
+                               k = surf_lsm_h%k(m)
+                               tend(k,j,i) = tend(k,j,i) + g / pt_reference    &
+                                                         * surf_lsm_h%shf(m)   
+                            ENDDO
+!
+!--                         Urban surfaces
+                            surf_s = surf_usm_h%start_index(j,i)
+                            surf_e = surf_usm_h%end_index(j,i)
+                            DO  m = surf_s, surf_e
+                               k = surf_usm_h%k(m)
+                               tend(k,j,i) = tend(k,j,i) + g / pt_reference    &
+                                                         * surf_usm_h%shf(m)   
+                            ENDDO                          
                          ENDIF
 
                          IF ( use_top_fluxes )  THEN
-                            k = nzt
-                            tend(k,j,i) = tend(k,j,i) + g / pt_reference * &
-                                                        tswst(j,i)
+                            surf_s = surf_def_h(2)%start_index(j,i)
+                            surf_e = surf_def_h(2)%end_index(j,i)
+                            DO  m = surf_s, surf_e
+                               k = surf_def_h(2)%k(m)
+                               tend(k,j,i) = tend(k,j,i) + g / pt_reference *     &
+                                                           surf_def_h(2)%shf(m) 
+                            ENDDO
                          ENDIF
                       ENDDO
@@ -579,9 +571,12 @@
 !--                   in the bottom and top surface layer
                       DO  j = nys, nyn
-                         DO  k = nzb_s_inner(j,i)+1, nzt
+                         DO  k = nzb+1, nzt
                             tend(k,j,i) = tend(k,j,i) +                        &
                                           kh(k,j,i) * g / prho(k,j,i) *        &
                                           ( prho(k+1,j,i) - prho(k-1,j,i) ) *  &
-                                          dd2zu(k)
+                                          dd2zu(k)                           * &
+                                     MERGE( 1.0_wp, 0.0_wp,                    &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                          )
                          ENDDO
                       ENDDO
@@ -590,21 +585,60 @@
 
                       DO  j = nys, nyn
-                         DO  k = nzb_diff_s_inner(j,i), nzt_diff
-                            tend(k,j,i) = tend(k,j,i) -                   &
-                                          kh(k,j,i) * g / pt(k,j,i) *     &
-                                          ( pt(k+1,j,i) - pt(k-1,j,i) ) * &
-                                          dd2zu(k)
+                         DO  k = nzb+1, nzt
+!
+!--                         Flag 9 is used to mask top fluxes, flag 30 to mask
+!--                         surface fluxes
+                            tend(k,j,i) = tend(k,j,i) -                        &
+                                          kh(k,j,i) * g / pt(k,j,i) *          &
+                                          ( pt(k+1,j,i) - pt(k-1,j,i) ) *      &
+                                          dd2zu(k)                      *      &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 30 )  &
+                                           )                            *      &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 9 )   &
+                                           ) 
                          ENDDO
 
                          IF ( use_surface_fluxes )  THEN
-                            k = nzb_diff_s_inner(j,i)-1
-                            tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * &
-                                                        shf(j,i)
+!
+!--                         Default surfaces, up- and downwrd-facing
+                            DO  l = 0, 1
+                               surf_s = surf_def_h(l)%start_index(j,i)
+                               surf_e = surf_def_h(l)%end_index(j,i)
+                               DO  m = surf_s, surf_e
+                                  k = surf_def_h(l)%k(m)
+                                  tend(k,j,i) = tend(k,j,i) + g / pt_reference &
+                                                         * surf_def_h(l)%shf(m)   
+                               ENDDO  
+                            ENDDO
+!
+!--                         Natural surfaces
+                            surf_s = surf_lsm_h%start_index(j,i)
+                            surf_e = surf_lsm_h%end_index(j,i)
+                            DO  m = surf_s, surf_e
+                               k = surf_lsm_h%k(m)
+                               tend(k,j,i) = tend(k,j,i) + g / pt_reference    &
+                                                         * surf_lsm_h%shf(m)   
+                            ENDDO  
+!
+!--                         Urban surfaces
+                            surf_s = surf_usm_h%start_index(j,i)
+                            surf_e = surf_usm_h%end_index(j,i)
+                            DO  m = surf_s, surf_e
+                               k = surf_usm_h%k(m)
+                               tend(k,j,i) = tend(k,j,i) + g / pt_reference    &
+                                                         * surf_usm_h%shf(m)   
+                            ENDDO  
                          ENDIF
 
                          IF ( use_top_fluxes )  THEN
-                            k = nzt
-                            tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * &
-                                                        tswst(j,i)
+                            surf_s = surf_def_h(2)%start_index(j,i)
+                            surf_e = surf_def_h(2)%end_index(j,i)
+                            DO  m = surf_s, surf_e
+                               k = surf_def_h(2)%k(m)
+                               tend(k,j,i) = tend(k,j,i) + g / pt_reference *     &
+                                                           surf_def_h(2)%shf(m) 
+                            ENDDO
                          ENDIF
                       ENDDO
@@ -618,6 +652,8 @@
                 DO  j = nys, nyn
 
-                   DO  k = nzb_diff_s_inner(j,i), nzt_diff
-
+                   DO  k = nzb+1, nzt
+!
+!--                   Flag 9 is used to mask top fluxes, flag 30 to mask
+!--                   surface fluxes
                       IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets ) THEN
                          k1 = 1.0_wp + 0.61_wp * q(k,j,i)
@@ -627,48 +663,11 @@
                                          ( k1 * ( pt(k+1,j,i)-pt(k-1,j,i) ) +  &
                                            k2 * ( q(k+1,j,i) - q(k-1,j,i) )    &
-                                         ) * dd2zu(k)
-                      ELSE IF ( cloud_physics )  THEN
-                         IF ( ql(k,j,i) == 0.0_wp )  THEN
-                            k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                            k2 = 0.61_wp * pt(k,j,i)
-                         ELSE
-                            theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
-                            temp  = theta * t_d_pt(k)
-                            k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *               &
-                                          ( q(k,j,i) - ql(k,j,i) ) *          &
-                                 ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
-                                 ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
-                                 ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
-                            k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
-                         ENDIF
-                         tend(k,j,i) = tend(k,j,i) - kh(k,j,i) *               &
-                                         g / vpt(k,j,i) *                      &
-                                         ( k1 * ( pt(k+1,j,i)-pt(k-1,j,i) ) +  &
-                                           k2 * ( q(k+1,j,i) - q(k-1,j,i) )    &
-                                         ) * dd2zu(k)
-                      ELSE IF ( cloud_droplets )  THEN
-                         k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
-                         k2 = 0.61_wp * pt(k,j,i)
-                         tend(k,j,i) = tend(k,j,i) -                          & 
-                                       kh(k,j,i) * g / vpt(k,j,i) *           &
-                                       ( k1 * ( pt(k+1,j,i)- pt(k-1,j,i) ) +  &
-                                         k2 * ( q(k+1,j,i) -  q(k-1,j,i) ) -  &
-                                         pt(k,j,i) * ( ql(k+1,j,i) -          &
-                                         ql(k-1,j,i) ) ) * dd2zu(k)
-                      ENDIF
-
-                   ENDDO
-
-                ENDDO
-
-                IF ( use_surface_fluxes )  THEN
-
-                   DO  j = nys, nyn
-
-                      k = nzb_diff_s_inner(j,i)-1
-
-                      IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets ) THEN
-                         k1 = 1.0_wp + 0.61_wp * q(k,j,i)
-                         k2 = 0.61_wp * pt(k,j,i)
+                                         ) * dd2zu(k) *                        &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 30 )  &
+                                           )          *                        &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 9 )   &
+                                           )
                       ELSE IF ( cloud_physics )  THEN
                          IF ( ql(k,j,i) == 0.0_wp )  THEN
@@ -685,13 +684,143 @@
                             k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
                          ENDIF
+                         tend(k,j,i) = tend(k,j,i) - kh(k,j,i) *               &
+                                         g / vpt(k,j,i) *                      &
+                                         ( k1 * ( pt(k+1,j,i)-pt(k-1,j,i) ) +  &
+                                           k2 * ( q(k+1,j,i) - q(k-1,j,i) )    &
+                                         ) * dd2zu(k) *                        &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 30 )  &
+                                           )          *                        &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 9 )   &
+                                           )
                       ELSE IF ( cloud_droplets )  THEN
                          k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
                          k2 = 0.61_wp * pt(k,j,i)
+                         tend(k,j,i) = tend(k,j,i) -                           & 
+                                       kh(k,j,i) * g / vpt(k,j,i) *            &
+                                       ( k1 * ( pt(k+1,j,i)- pt(k-1,j,i) ) +   &
+                                         k2 * ( q(k+1,j,i) -  q(k-1,j,i) ) -   &
+                                         pt(k,j,i) * ( ql(k+1,j,i) -           &
+                                         ql(k-1,j,i) ) ) * dd2zu(k) *          &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 30 )  &
+                                           )                        *          &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 9 )   &
+                                           )
                       ENDIF
 
-                      tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) * &
-                                            ( k1* shf(j,i) + k2 * qsws(j,i) )
                    ENDDO
 
+                ENDDO
+
+                IF ( use_surface_fluxes )  THEN
+
+                   DO  j = nys, nyn
+!
+!--                   Treat horizontal default surfaces, up- and downward-facing
+                      DO  l = 0, 1
+                         surf_s = surf_def_h(l)%start_index(j,i)
+                         surf_e = surf_def_h(l)%end_index(j,i)
+                         DO  m = surf_s, surf_e
+                            k = surf_def_h(l)%k(m)
+
+                            IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets ) THEN
+                               k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                               k2 = 0.61_wp * pt(k,j,i)
+                            ELSE IF ( cloud_physics )  THEN
+                               IF ( ql(k,j,i) == 0.0_wp )  THEN
+                                  k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                                  k2 = 0.61_wp * pt(k,j,i)
+                               ELSE
+                                  theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
+                                  temp  = theta * t_d_pt(k)
+                                  k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *         &
+                                             ( q(k,j,i) - ql(k,j,i) ) *        &
+                                    ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /   &
+                                    ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *     &
+                                    ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                                  k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
+                               ENDIF
+                            ELSE IF ( cloud_droplets )  THEN
+                               k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                               k2 = 0.61_wp * pt(k,j,i)
+                            ENDIF
+
+                            tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) *       &
+                                               ( k1 * surf_def_h(l)%shf(m) +   &
+                                                 k2 * surf_def_h(l)%qsws(m) )
+                         ENDDO
+                      ENDDO
+!
+!--                   Treat horizontal natural surfaces
+                      surf_s = surf_lsm_h%start_index(j,i)
+                      surf_e = surf_lsm_h%end_index(j,i)
+                      DO  m = surf_s, surf_e
+                         k = surf_lsm_h%k(m)
+
+                         IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets ) THEN
+                            k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                            k2 = 0.61_wp * pt(k,j,i)
+                         ELSE IF ( cloud_physics )  THEN
+                            IF ( ql(k,j,i) == 0.0_wp )  THEN
+                               k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                               k2 = 0.61_wp * pt(k,j,i)
+                            ELSE
+                               theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
+                               temp  = theta * t_d_pt(k)
+                               k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *            &
+                                             ( q(k,j,i) - ql(k,j,i) ) *        &
+                                    ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /   &
+                                    ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *     &
+                                    ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                               k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
+                            ENDIF
+                         ELSE IF ( cloud_droplets )  THEN
+                            k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                            k2 = 0.61_wp * pt(k,j,i)
+                         ENDIF
+
+                         tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) *          &
+                                               ( k1 * surf_lsm_h%shf(m) +      &
+                                                 k2 * surf_lsm_h%qsws(m) )
+                      ENDDO
+!
+!--                   Treat horizontal urban surfaces
+                      surf_s = surf_usm_h%start_index(j,i)
+                      surf_e = surf_usm_h%end_index(j,i)
+                      DO  m = surf_s, surf_e
+                         k = surf_lsm_h%k(m)
+
+                         IF ( .NOT. cloud_physics .AND. .NOT. cloud_droplets ) THEN
+                            k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                            k2 = 0.61_wp * pt(k,j,i)
+                         ELSE IF ( cloud_physics )  THEN
+                            IF ( ql(k,j,i) == 0.0_wp )  THEN
+                               k1 = 1.0_wp + 0.61_wp * q(k,j,i)
+                               k2 = 0.61_wp * pt(k,j,i)
+                            ELSE
+                               theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
+                               temp  = theta * t_d_pt(k)
+                               k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *            &
+                                             ( q(k,j,i) - ql(k,j,i) ) *        &
+                                    ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /   &
+                                    ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *     &
+                                    ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
+                               k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
+                            ENDIF
+                         ELSE IF ( cloud_droplets )  THEN
+                            k1 = 1.0_wp + 0.61_wp * q(k,j,i) - ql(k,j,i)
+                            k2 = 0.61_wp * pt(k,j,i)
+                         ENDIF
+
+                         tend(k,j,i) = tend(k,j,i) + g / vpt(k,j,i) *          &
+                                               ( k1 * surf_usm_h%shf(m) +      &
+                                                 k2 * surf_usm_h%qsws(m) )
+                      ENDDO
+
+                   ENDDO
+
                 ENDIF
 
